{****************************************************}
{ 		CObject.p}
{}
{		Interface for the Object Class}
{}
{		Abstract class which is at the root of the class hierarchy. CObject }
{		is the only class which does not have a superclass.  }
{}
{	    	SUPERCLASS = None }
{}
{		Copyright  1989, Symantec Corporation.  All rights reserved.			}
{}
{****************************************************}

unit CObject;

interface

	uses
		MiniIntf;

implementation


{****************************************************}
{ Free }
{}
{		Dispose of an object by freeing the block of memory it occupies. }
{}
{****************************************************}
	procedure CObject.Free;
	begin
		DisposHandle(Handle(SELF));
	end;


{****************************************************}
{ Clone }
{}
{		Make a copy of an object}
{}
{****************************************************}
	function CObject.Clone: CObject;
		var
			copyOfObject: Handle;
			temp: OSErr;
	begin
		copyOfObject := Handle(SELF);
		temp := HandToHand(copyOfObject);
		Clone := CObject(copyOfObject);
	end;
end.